.install_poetry: &install_poetry
  - cd ./backend
  - pip install "poetry==1.1.13"
  - poetry config virtualenvs.in-project true && poetry install -vv && poetry --version

#include:
#  - local: frontend/.gitlab/.gitlab-ci-frontend-tests.yml

stages:
  - prepare
  - project-test
  - code-check

prepare:req: &prepare
  stage: prepare
  image: python:3.9
  script:
    - *install_poetry

tests:
  stage: project-test
  image:
    name: docker/compose:latest
  services:
    - docker:dind
  script:
    - docker-compose -f backend/docker-compose.yml run django test

code-check:flake8:
  <<: *prepare
  stage: code-check
  before_script:
    - *install_poetry
  script:
    - poetry run ./linters/flake8.bash
  dependencies:
    - prepare:req

code-check:black:
  <<: *prepare
  stage: code-check
  before_script:
    - *install_poetry
  script:
    - poetry show black
    - poetry run ./linters/black-check.bash --diff
  dependencies:
    - prepare:req

code-check:isort:
  <<: *prepare
  stage: code-check
  before_script:
    - *install_poetry
  script:
    - poetry run ./linters/isort-check.bash
  dependencies:
    - prepare:req

